Index: orxonox/branches/openAL/src/world_entities/player.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/player.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/player.cc	(revision 4194)
@@ -1,4 +1,2 @@
-
-
 /* 
    orxonox - the future of 3D-vertical-scrollers
@@ -31,4 +29,6 @@
 
 using namespace std;
+
+CREATE_FACTORY(Player);
 
 /**
@@ -52,9 +52,9 @@
   //weapons:
   this->weaponMan = new WeaponManager();
-  Weapon* wpRight = new TestGun(this,Vector(-2.6, 0.1, 3.0), Quaternion(), 0);
+  Weapon* wpRight = new TestGun(this, Vector(-2.6, 0.1, 3.0), Quaternion(), 0);
   Weapon* wpLeft = new TestGun(this, Vector(-2.6, 0.1, -3.0), Quaternion(), 1);
   
-  this->weaponMan->addWeapon(wpRight, W_CONFIG0);
-  this->weaponMan->addWeapon(wpLeft, W_CONFIG1);
+  this->weaponMan->addWeapon(wpRight, W_CONFIG0, W_SLOT0);
+  this->weaponMan->addWeapon(wpLeft, W_CONFIG1, W_SLOT1);
   this->weaponMan->addWeapon(wpRight, W_CONFIG2);
   this->weaponMan->addWeapon(wpLeft, W_CONFIG2);
@@ -74,4 +74,35 @@
 }
 
+/**
+   \brief creates a new Player from Xml Data
+   \param root the xml element containing player data
+   
+   \todo add more parameters to load
+*/
+Player::Player(TiXmlElement* root) : WorldEntity(root)
+{
+  this->weapons = new tList<Weapon>();
+  this->activeWeapon = NULL;
+  /*
+    this is the debug player - actualy we would have to make a new
+     class derivated from Player for each player. for now, we just use
+     the player.cc for debug also
+  */
+  travelSpeed = 15.0;
+  velocity = new Vector();
+  bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
+  bFire = false;
+  this->bWeaponChange = false;
+  acceleration = 10.0;
+  //weapons:
+  this->weaponMan = new WeaponManager();
+  Weapon* wpRight = new TestGun(this, Vector(-2.6, 0.1, 3.0), Quaternion(), 0);
+  Weapon* wpLeft = new TestGun(this, Vector(-2.6, 0.1, -3.0), Quaternion(), 1);
+  
+  this->weaponMan->addWeapon(wpRight, W_CONFIG0, W_SLOT0);
+  this->weaponMan->addWeapon(wpLeft, W_CONFIG1, W_SLOT1);
+  this->weaponMan->addWeapon(wpRight, W_CONFIG2);
+  this->weaponMan->addWeapon(wpLeft, W_CONFIG2);
+}
 
 /**
@@ -188,11 +219,11 @@
   //orthDirection = orthDirection.cross (direction);
 
-  if( this->bUp && this->getRelCoor()->x < 20)
+  if( this->bUp && this->getRelCoor().x < 20)
     accel = accel+(direction*acceleration);
-  if( this->bDown && this->getRelCoor()->x > -5)
+  if( this->bDown && this->getRelCoor().x > -5)
     accel = accel-(direction*acceleration);
-  if( this->bLeft &&  TrackManager::getInstance()->getWidth() > -this->getRelCoor()->z*2)
+  if( this->bLeft &&  TrackManager::getInstance()->getWidth() > -this->getRelCoor().z*2)
     accel = accel - (orthDirection*acceleration); 
-  if( this->bRight &&  TrackManager::getInstance()->getWidth() > this->getRelCoor()->z*2)
+  if( this->bRight &&  TrackManager::getInstance()->getWidth() > this->getRelCoor().z*2)
     accel = accel + (orthDirection*acceleration);
   if( this->bAscend )
@@ -230,9 +261,9 @@
 {
   PRINTF(3)("recieved command [%s]\n", cmd->cmd);
-  if( !strcmp( cmd->cmd, "up")) this->bUp = !cmd->bUp;
-  if( !strcmp( cmd->cmd, "down")) this->bDown = !cmd->bUp;
-  if( !strcmp( cmd->cmd, "left")) this->bLeft = !cmd->bUp;
-  if( !strcmp( cmd->cmd, "right")) this->bRight = !cmd->bUp;
-  if( !strcmp( cmd->cmd, "fire")) this->bFire = !cmd->bUp;
-  if( !strcmp( cmd->cmd, "mode")) if(cmd->bUp) this->bWeaponChange = !this->bWeaponChange;
-}
+  if( !strcmp( cmd->cmd, CONFIG_NAME_PLAYER_UP)) this->bUp = !cmd->bUp;
+  if( !strcmp( cmd->cmd, CONFIG_NAME_PLAYER_DOWN)) this->bDown = !cmd->bUp;
+  if( !strcmp( cmd->cmd, CONFIG_NAME_PLAYER_LEFT)) this->bLeft = !cmd->bUp;
+  if( !strcmp( cmd->cmd, CONFIG_NAME_PLAYER_RIGHT)) this->bRight = !cmd->bUp;
+  if( !strcmp( cmd->cmd, CONFIG_NAME_PLAYER_FIRE)) this->bFire = !cmd->bUp;
+  if( !strcmp( cmd->cmd, CONFIG_NAME_PLAYER_NEXT_WEAPON)) if(cmd->bUp) this->bWeaponChange = !this->bWeaponChange;
+}
Index: orxonox/branches/openAL/src/world_entities/player.h
===================================================================
--- orxonox/branches/openAL/src/world_entities/player.h	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/player.h	(revision 4194)
@@ -22,4 +22,5 @@
  public:
   Player();
+  Player(TiXmlElement* root);
   virtual ~Player();
 
Index: orxonox/branches/openAL/src/world_entities/skybox.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/skybox.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/skybox.cc	(revision 4194)
@@ -28,5 +28,7 @@
 
 #include "skybox.h"
+
 #include "stdincl.h"
+#include "factory.h"
 
 #include "material.h"
@@ -36,4 +38,5 @@
 //#include "world_entity.h"
 
+CREATE_FACTORY(SkyBox);
 
 using namespace std;
@@ -45,7 +48,35 @@
 SkyBox::SkyBox(char* fileName)
 {
+  this->preInit();
+  this->postInit();
+}
+
+SkyBox::SkyBox(TiXmlElement* root) : WorldEntity(root)
+{
+  this->preInit();
+
+  const char* string;
+
+  // Model Loading	
+  string = grabParameter( root, "materialset");
+  if( string != NULL)
+    this->setTexture(string, "jpg");
+  else
+    {
+      PRINTF(0)("SkyBox is missing a proper 'MaterialSet'\n");
+    }
+  if( this->skyModel == NULL)
+    {
+      PRINTF(0)("SkyBox model '%s' could not be loaded\n", string);
+    }
+  this->postInit();
+}
+
+void SkyBox::preInit(void)
+{
   this->setClassName("SkyBox");
+  this->skyModel = NULL;
   this->material = new Material*[6];
-  for (int i = 0; i <6; i++) 
+  for (int i = 0; i < 6; i++) 
     {
       this->material[i] = new Material();
@@ -56,6 +87,10 @@
     }
   this->setMode(PNODE_MOVEMENT);
-
+}
+
+void SkyBox::postInit(void)
+{
   this->setSize(1900.0);
+  this->rebuild();
 }
 
@@ -66,6 +101,5 @@
 SkyBox::~SkyBox()
 {
-  PRINTF(5)("Deleting the SkyBox\n");
-  
+  PRINTF(5)("Deleting SkyBox\n");
   for (int i = 0; i < 6; i++)
     delete this->material[i];
@@ -84,10 +118,10 @@
 void SkyBox::setTexture(const char* name, const char* extension)
 {
-  char* top    = new char[strlen(name)+strlen(extension)+ 6];
-  char* bottom = new char[strlen(name)+strlen(extension)+ 9];
-  char* left   = new char[strlen(name)+strlen(extension)+ 7];
-  char* right  = new char[strlen(name)+strlen(extension)+ 8];
-  char* front  = new char[strlen(name)+strlen(extension)+ 8];
-  char* back   = new char[strlen(name)+strlen(extension)+ 7];
+  char* top    = new char[strlen(name)+strlen(extension)+ 10];
+  char* bottom = new char[strlen(name)+strlen(extension)+ 10];
+  char* left   = new char[strlen(name)+strlen(extension)+ 10];
+  char* right  = new char[strlen(name)+strlen(extension)+ 10];
+  char* front  = new char[strlen(name)+strlen(extension)+ 10];
+  char* back   = new char[strlen(name)+strlen(extension)+ 10];
 
   sprintf(top, "%s_top.%s", name, extension);
@@ -100,4 +134,5 @@
   this->setTextures(top, bottom, left, right, front, back);
 
+  // deleted alocated memory of this function
   delete []top;
   delete []bottom;
@@ -125,6 +160,4 @@
   this->material[4]->setDiffuseMap(front);
   this->material[5]->setDiffuseMap(back);
-
-  this->rebuild();
 }
 
@@ -135,6 +168,4 @@
 {
   this->size = size;
-
-  this->rebuild();
 }
 
@@ -149,5 +180,5 @@
   glTranslatef(r.x, r.y, r.z);
 
-  this->model->draw();
+  this->skyModel->draw();
 
   glPopMatrix();
@@ -162,42 +193,42 @@
 void SkyBox::rebuild()
 {
-  if (this->model)
-    delete model;
-  model = new Model();
-
-  model->addVertex (-0.5*size, -0.5*size, 0.5*size);  
-  model->addVertex (0.5*size, -0.5*size, 0.5*size);
-  model->addVertex (-0.5*size, 0.5*size, 0.5*size);
-  model->addVertex (0.5*size, 0.5*size, 0.5*size);
-  model->addVertex (-0.5*size, 0.5*size, -0.5*size);
-  model->addVertex (0.5*size, 0.5*size, -0.5*size);
-  model->addVertex (-0.5*size, -0.5*size, -0.5*size);
-  model->addVertex (0.5*size, -0.5*size, -0.5*size);
-
-  model->addVertexTexture (0.0, 0.0);
-  model->addVertexTexture (1.0, 0.0);
-  model->addVertexTexture (1.0, 1.0);
-  model->addVertexTexture (0.0, 1.0);
-
-  model->addVertexNormal (0.0, 0.0, 1.0);
-  model->addVertexNormal (0.0, 1.0, 0.0);
-  model->addVertexNormal (0.0, 0.0, -1.0);
-  model->addVertexNormal (0.0, -1.0, 0.0);
-  model->addVertexNormal (1.0, 0.0, 0.0);
-  model->addVertexNormal (-1.0, 0.0, 0.0);
-
-  model->setMaterial(material[0]);
-  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 3,2,4, 4,3,4, 6,4,4, 5,1,4); // top
-  model->setMaterial(material[1]);
-  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,4,2, 8,1,2, 2,2,2, 1,3,2); // bottom
-  model->setMaterial(material[2]);
-  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 1,1,3, 2,2,3, 4,3,3, 3,4,3); // left
-  model->setMaterial(material[3]);
-  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 5,3,1, 6,4,1, 8,1,1, 7,2,1); // right
-  model->setMaterial(material[4]);
-  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 2,1,6, 8,2,6, 6,3,6, 4,4,6); // front
-  model->setMaterial(material[5]);
-  model->addFace (4, VERTEX_TEXCOORD_NORMAL, 7,1,5, 1,2,5, 3,3,5, 5,4,5); // back
+  if (this->skyModel)
+    delete skyModel;
+  skyModel = new Model();
+
+  this->skyModel->addVertex (-0.5*size, -0.5*size, 0.5*size);  
+  this->skyModel->addVertex (0.5*size, -0.5*size, 0.5*size);
+  this->skyModel->addVertex (-0.5*size, 0.5*size, 0.5*size);
+  this->skyModel->addVertex (0.5*size, 0.5*size, 0.5*size);
+  this->skyModel->addVertex (-0.5*size, 0.5*size, -0.5*size);
+  this->skyModel->addVertex (0.5*size, 0.5*size, -0.5*size);
+  this->skyModel->addVertex (-0.5*size, -0.5*size, -0.5*size);
+  this->skyModel->addVertex (0.5*size, -0.5*size, -0.5*size);
+
+  this->skyModel->addVertexTexture (0.0, 0.0);
+  this->skyModel->addVertexTexture (1.0, 0.0);
+  this->skyModel->addVertexTexture (1.0, 1.0);
+  this->skyModel->addVertexTexture (0.0, 1.0);
+
+  this->skyModel->addVertexNormal (0.0, 0.0, 1.0);
+  this->skyModel->addVertexNormal (0.0, 1.0, 0.0);
+  this->skyModel->addVertexNormal (0.0, 0.0, -1.0);
+  this->skyModel->addVertexNormal (0.0, -1.0, 0.0);
+  this->skyModel->addVertexNormal (1.0, 0.0, 0.0);
+  this->skyModel->addVertexNormal (-1.0, 0.0, 0.0);
+
+  this->skyModel->setMaterial(material[0]);
+  this->skyModel->addFace (4, VERTEX_TEXCOORD_NORMAL, 2,1,3, 3,2,3, 5,3,3, 4,0,3); // top
+  this->skyModel->setMaterial(material[1]);
+  this->skyModel->addFace (4, VERTEX_TEXCOORD_NORMAL, 6,3,1, 7,0,1, 1,1,1, 0,2,1); // bottom
+  this->skyModel->setMaterial(material[2]);
+  this->skyModel->addFace (4, VERTEX_TEXCOORD_NORMAL, 0,0,2, 1,1,2, 3,2,2, 2,3,2); // left
+  this->skyModel->setMaterial(material[3]);
+  this->skyModel->addFace (4, VERTEX_TEXCOORD_NORMAL, 4,2,0, 5,3,0, 7,0,0, 6,1,0); // right
+  this->skyModel->setMaterial(material[4]);
+  this->skyModel->addFace (4, VERTEX_TEXCOORD_NORMAL, 1,0,5, 7,1,5, 5,2,5, 3,3,6); // front
+  this->skyModel->setMaterial(material[5]);
+  this->skyModel->addFace (4, VERTEX_TEXCOORD_NORMAL, 6,0,4, 0,1,4, 2,2,4, 4,3,4); // back
   
-  model->finalize();
-}
+  this->skyModel->finalize();
+}
Index: orxonox/branches/openAL/src/world_entities/skybox.h
===================================================================
--- orxonox/branches/openAL/src/world_entities/skybox.h	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/skybox.h	(revision 4194)
@@ -22,5 +22,11 @@
  public:
   SkyBox(char* fileName = NULL);
+  SkyBox(TiXmlElement* root);
+
   virtual ~SkyBox();
+
+  void preInit(void);
+  void postInit(void);
+
 
   void setSize(float size);
@@ -33,4 +39,5 @@
   void rebuild();
 
+  Model* skyModel;        //!< A Model for the Sky. This must not be the same as the Model from WorldEntity, because it is not alocated through the ResourceManager.
   Material **material;    //!< Materials for the SkyBox. sorted by number (0-5) top, bottom, left, right, front, back
   float size;             //!< Size of the SkyBox. This should match the frustum maximum range.
Index: orxonox/branches/openAL/src/world_entities/skysphere.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/skysphere.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/skysphere.cc	(revision 4194)
@@ -44,5 +44,5 @@
 {
   if (fileName == NULL)
-    this->initialize("../data/pictures/sky-replace.jpg");
+    this->initialize("pictures/sky-replace.jpg");
   else
     this->initialize(fileName);
Index: orxonox/branches/openAL/src/world_entities/terrain.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/terrain.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/terrain.cc	(revision 4194)
@@ -77,7 +77,7 @@
 void Terrain::init(void)
 {
-   this->setClassName ("Terrain");
-
-   this->objectList = 0;
+  this->setClassName ("Terrain");
+  
+  this->objectList = 0;
 }
 
@@ -98,9 +98,8 @@
   glMultMatrixf((float*)matrix);
 
-  if (objectList)
-    glCallList(objectList);
-  else if (model)
-    model->draw();
-  //  this->model->draw();
+  if (this->objectList)
+    glCallList(this->objectList);
+  else if (this->model)
+    this->model->draw();
   glPopMatrix();
 }
Index: orxonox/branches/openAL/src/world_entities/test_gun.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/test_gun.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/test_gun.cc	(revision 4194)
@@ -49,15 +49,25 @@
   this->objectComponent1 = new PNode();
   this->animation1 = new Animation3D(this->objectComponent1);
-  parent->addChild(this->objectComponent1, PNODE_ALL);
+  this->animation2 = new Animation3D(this);
+  this->animation3 = new Animation3D(this);
+  //parent->addChild(this->objectComponent1, PNODE_ALL);
+  this->addChild(this->objectComponent1, PNODE_ALL);
 
   this->animation1->setInfinity(ANIM_INF_CONSTANT);
-  // ANIM_LINEAR was ANIM_NEG_EXP
+  this->animation2->setInfinity(ANIM_INF_CONSTANT);
+  this->animation3->setInfinity(ANIM_INF_CONSTANT);
   if( this->leftRight == W_LEFT)
     {
       this->projectileOffset = Vector(1.0, 0.0, -0.35);
 
-      this->animation1->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR); 
-      this->animation1->addKeyFrame(Vector(-3.0, 0.1, 3.0), Quaternion(), 0.5, ANIM_LINEAR);
-      this->animation1->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR);
+      this->animation1->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT); 
+      this->animation1->addKeyFrame(Vector(-0.4, 0, 0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT);
+      this->animation1->addKeyFrame(Vector(0, 0, 0), Quaternion(), 0.0, ANIM_LINEAR, ANIM_CONSTANT);
+
+      this->animation2->addKeyFrame(Vector(-2.6, 0.1, 2.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT); 
+      this->animation2->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT);
+
+      this->animation3->addKeyFrame(Vector(-2.6, 0.1, 3.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT);
+      this->animation3->addKeyFrame(Vector(-2.6, 0.1, 2.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT); 
     }
   else if( this->leftRight == W_RIGHT)
@@ -65,8 +75,16 @@
       this->projectileOffset = Vector(1.0, 0.0, 0.5);
 
-      this->animation1->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.1, ANIM_LINEAR);
-      this->animation1->addKeyFrame(Vector(-3.0, 0.1, -2.5), Quaternion(), 0.5, ANIM_LINEAR);
-      this->animation1->addKeyFrame(Vector(-2.6, 0.1, -2.5), Quaternion(), 0.1, ANIM_LINEAR);
+      this->objectComponent1->setRelCoor(Vector(0,0,0.35));
+      this->animation1->addKeyFrame(Vector(0, 0, .5), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT); 
+      this->animation1->addKeyFrame(Vector(-0.4, 0, .5), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT);
+      this->animation1->addKeyFrame(Vector(0, 0, .5), Quaternion(), 0.0, ANIM_LINEAR, ANIM_CONSTANT);
+
+      this->animation2->addKeyFrame(Vector(-2.6, 0.1, -2.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT); 
+      this->animation2->addKeyFrame(Vector(-2.6, 0.1, -3.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT);
+
+      this->animation3->addKeyFrame(Vector(-2.6, 0.1, -3.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT);
+      this->animation3->addKeyFrame(Vector(-2.6, 0.1, -2.0), Quaternion(), 0.1, ANIM_LINEAR, ANIM_CONSTANT); 
     }
+
 }
 
@@ -89,5 +107,7 @@
 */
 void TestGun::activate()
-{}
+{
+  this->animation2->replay();
+}
 
 
@@ -100,5 +120,7 @@
 */
 void TestGun::deactivate()
-{}
+{
+  this->animation3->replay();
+}
 
 
Index: orxonox/branches/openAL/src/world_entities/weapon.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/weapon.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/weapon.cc	(revision 4194)
@@ -110,22 +110,36 @@
 void WeaponManager::nextWeaponConf() 
 {
-  PRINTF(4)("Changing weapon configuration: from %i\n", this->currConfID);
-
-  Weapon* w;
-  for(int i = 0; i < W_MAX_SLOTS; ++i)
-    {
-      w = this->configs[this->currConfID].slots[i];
-      if( w != NULL) w->deactivate();
-    }
-  int i;
+  PRINTF(4)("Changing weapon configuration: from %i to next\n", this->currConfID);
+
+  int i, lastConfID;
+  lastConfID = this->currConfID;
   for(i = this->currConfID + 1; i < W_MAX_CONFIGS && !this->configs[i].bUsed; ++i);
   if( i == W_MAX_CONFIGS) this->currConfID = W_CONFIG0;
   else this->currConfID = i;  
-  PRINTF(4)("\tto %i\n", this->currConfID);
-
-  for(int i = 0; i < W_MAX_SLOTS; ++i)
-    {
-      w = this->configs[this->currConfID].slots[i];
-      if( w != NULL) w->activate();
+
+  
+  Weapon *w1, *w2;
+  for(int j = 0; j < W_MAX_SLOTS; ++j)
+    {
+      w1 = this->configs[lastConfID].slots[j];
+      w2 = this->configs[this->currConfID].slots[j];
+      
+      if( w1 == w2)
+	{
+	  printf("no need for change\n");
+	}
+      else
+	{
+	if( w1 != NULL )
+	  {
+	    w1->deactivate();
+	    printf("deactivating %i,%i\n", j,lastConfID);
+	  }
+	if( w2 != NULL)
+	  {
+	    w2->activate();
+	    printf("activating %i,%i\n", j, this->currConfID);
+	  }
+	}
     }
 }
Index: orxonox/branches/openAL/src/world_entities/world_entity.cc
===================================================================
--- orxonox/branches/openAL/src/world_entities/world_entity.cc	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/world_entity.cc	(revision 4194)
@@ -30,13 +30,6 @@
 /**
    \brief standard constructor
-   
-   Every derived contructor HAS to call the previous one supplying the isFree parameter. This is necessary to distunguish
-   between free and bound entities. The difference between them is simply the fact that the movement of a free entity is
-   not bound to the track of a world. Use this to implement projectile or effect classes that do not have to travel along the track.
-   To specify an entity to be free or bound set the default parameter in the declaration of the constructor.
-   Theoretically you should never have to call the constructor of an Entity directly, for it is called by the spawn() function of the World
-   class. So if you want to create a new entity at any time, call World::spawn(). It will handle everything that is necessary.
-*/
-WorldEntity::WorldEntity (bool isFree) : bFree(isFree)
+*/
+WorldEntity::WorldEntity ()
 {
   this->setClassName ("WorldEntity");
@@ -47,4 +40,44 @@
 
 /**
+   \brief Loads the WordEntity-specific Part of any derived Class
+*/
+WorldEntity::WorldEntity(TiXmlElement* root)
+{
+  // Name Setup
+  char* temp;
+  const char* string;
+  string = grabParameter( root, "name");
+  if( string == NULL)
+    {
+      PRINTF(2)("WorldEntity is missing a proper 'name'\n");
+      string = "Unknown";
+      temp = new char[strlen(string + 2)];
+      strcpy( temp, string);
+      this->setName( temp);
+    }
+  else
+    {
+      temp = new char[strlen(string + 2)];
+      strcpy( temp, string);
+      this->setName( temp);
+    }
+  // Model Loading	
+  this->model = NULL;
+  string = grabParameter( root, "model");
+  if( string != NULL)
+    this->model = (Model*)ResourceManager::getInstance()->load(string, OBJ, RP_CAMPAIGN);
+  else
+    {
+      PRINTF(2)("WorldEntity is missing a proper 'model'\n");
+      this->model = NULL;
+    }
+  if( this->model == NULL)
+    {
+      PRINTF(2)("WorldEntity model '%s' could not be loaded\n", string);
+    }
+  this->bDraw = true;
+}
+
+/**
    \brief standard destructor
 */
@@ -73,13 +106,4 @@
 {}
 
-
-/**
-   \brief query whether the WorldEntity in question is free
-   \return true if the WorldEntity is free or false if it isn't
-*/
-bool WorldEntity::isFree ()
-{
-  return bFree;
-}
 
 /**
Index: orxonox/branches/openAL/src/world_entities/world_entity.h
===================================================================
--- orxonox/branches/openAL/src/world_entities/world_entity.h	(revision 3921)
+++ orxonox/branches/openAL/src/world_entities/world_entity.h	(revision 4194)
@@ -23,5 +23,6 @@
 
  public:
-  WorldEntity (bool isFree = false);
+  WorldEntity (void);
+  WorldEntity(TiXmlElement* root);
   virtual ~WorldEntity ();
 
@@ -32,5 +33,4 @@
   //void removeAbility(Ability* ability);
   void setDrawable (bool bDraw);  
-  bool isFree ();
   void setCharacterAttributes(CharacterAttributes* charAttr);
   CharacterAttributes* getCharacterAttributes();
@@ -52,5 +52,4 @@
   
  private:
-  const bool bFree;	              //!< If the entity is free.
   bool bCollide;                      //!< If it should be considered for the collisiontest.
   bool bDraw;                         //!< If it should be visible.
